package weka.filters.unsupervised.attribute;


import com.github.fommil.netlib.BLAS;
import no.uib.cipr.matrix.*;
import no.uib.cipr.matrix.Matrix;
import no.uib.cipr.matrix.Vector;
import weka.core.*;
import weka.filters.SimpleBatchFilter;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.*;
import java.util.function.IntFunction;
import java.util.logging.ConsoleHandler;
import java.util.logging.LogRecord;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;
import java.util.stream.DoubleStream;
import java.util.stream.IntStream;

/**
 * A filter that can be used to process a collection of images for classification or clustering. It applies
 * spherical k-means to image batches extracted from the first batch of images it receives and uses
 * the resulting k-means centroids to process images into feature vectors suitable for classification or
 * clustering.
 *
 * The first attribute in the input data is required to be a string attribute with the file names of images.
 */
public class KMeansImageFilter extends SimpleBatchFilter {

    /**
     * Logger
     */
    static final Logger LOGGER = Logger.getLogger(KMeansImageFilter.class.getName());

    /** The last measured nanosecond. */
    private long lastNanos = 0;

    /** A table storing accumulated execution time (in milliseconds) */
    private Map<String, Double> accumulatedMicros = new TreeMap<>();

    /** A switch to control whether the normalization step of the input observations
     * is performed globally or per-channel.
     */
    protected boolean m_channel_normalize = true;

    /** The seed for the random number generator. */
    protected int m_seed = 0;

    /** The width and height of each extracted image patch in pixels. */
    protected int m_cropSize = 8;

    /** The number of patches to be extracted from each image. */
    protected int m_numPatchesPerImage = 1;

    /** The number of clusters aka filters aka dictionary atoms to use. */
    protected int m_K = 1000;

    /** The stride for the application of the filters (when feature vectors are computed). */
    protected int m_stride = 4;

    /** The height and width of the pool used to reduce the dimensionality of the feature vectors. */
    protected int m_poolSize = 2;

    /** The dictionary matrix, with one column per filter (aka atom). */
    protected Matrix m_D;


    static {
        ConsoleHandler handler = new ConsoleHandler();
        handler.setFormatter(new SimpleFormatter() {
            private static final String format = "[%1$tF %1$tH:%1$tM:%1$tS.%1$tL] [COMPX521] [%2$-4s] %3$s %n";

            @Override
            public String format(LogRecord record) {
                return String.format(format,
                        new Date(record.getMillis()),
                        record.getLevel().getLocalizedName(),
                        record.getMessage());
            }
        });
        LOGGER.setUseParentHandlers(false);
        LOGGER.addHandler(handler);
    }


    /**
     * The method used to add a measuring point that the time period since last measurement is added to the
     * entry specified by "key".
     * @param key the name of measurement slot
     */
    protected void addMeasurementTo(String key) {
        double val = 0;
        if (accumulatedMicros.containsKey(key)) {
            val = accumulatedMicros.get(key);
        }

        long currNanos = System.nanoTime();
        val += currNanos - lastNanos;
        lastNanos = currNanos;

        accumulatedMicros.put(key, val);
    }

    /**
     * The method used to establish the format of the data generated by this filter, as an Instances object.
     *
     * @param data the input dataset, with a string attribute containing the file names of the images
     * @return an Instances object that provides the "header" information for the data generated by this filter
     * (i.e., an Instances object that does not contain any actual instances but does contain a list of attributes).
     */
    public Instances determineOutputFormat(Instances data) {

        if (m_Debug) {
            System.err.println("Determining output format.");
        }
        int imgSize = -1;
        for (int i = 0; i < data.numInstances(); i++) {
            String fileName = data.instance(i).stringValue(0);
            BufferedImage img = null;
            try {
                img = ImageIO.read(new File(fileName));
            } catch (Exception ex) {
                System.err.println("Could not load: " + fileName);
            }
            if (img.getWidth() != img.getHeight()) {
                throw new IllegalArgumentException("Image " + fileName + " is not square.");
            }
            if (imgSize == -1) {
                imgSize = img.getWidth();
            } else if (imgSize != img.getWidth()) {
                throw new IllegalArgumentException("Image " + fileName + " has different size.");
            }
        }
        if (m_Debug) {
            System.err.println("Image size is: " + imgSize);
        }
        if (((imgSize - m_cropSize) % m_stride) != 0) {
            throw new IllegalArgumentException("Image height not compatible with patch size and stride");
        }
        if ((1 + ((imgSize - m_cropSize) / m_stride)) % m_poolSize != 0) {
            throw new IllegalArgumentException("Pool size not compatible with raw features.");
        }

        int nFeatPerFilterAndDimension = (1 + ((imgSize - m_cropSize) / m_stride)) / m_poolSize;
        int numFeatures = nFeatPerFilterAndDimension * nFeatPerFilterAndDimension * m_K;

        ArrayList<Attribute> atts = new ArrayList<>(numFeatures + 1);
        for (int i = 0; i < numFeatures; i++) {
            atts.add(new Attribute("x" + (i + 1)));
        }
        if (data.classIndex() > -1) {
            atts.add((Attribute) data.classAttribute().copy());
        }
        Instances output = new Instances("features", atts, 0);
        output.setClassIndex(output.numAttributes() - 1);
        if (m_Debug) {
            System.err.println("Finished determining output format with " + output.numAttributes() + " attributes.");
        }
        return output;

    }

    /**
     * The method that processes the given dataset and outputs the filtered data.
     *
     * @param data the input data to be filtered, with a string attribute containing the file names of the images
     * @return the filtered data, consisting of feature vectors ready for other machine learning algorithms
     */
    public Instances process(Instances data) throws Exception {

        // We will need a random number generator
        Random rand = new Random(m_seed);

        // Establish number of rows and columns for data matrix X
        int numPatchPixels = m_cropSize * m_cropSize;
        int numPatchValues = numPatchPixels * 3; // Three colour channels
        int numPatches = m_numPatchesPerImage * data.numInstances();

        // Create constant vectors that we will reuse many times to center the values in each patch
        Vector oneOverNumPatchValues = constantVector(1.0 / numPatchValues, numPatchValues);
        Vector allOnesNumPatchValues = constantVector(1.0, numPatchValues);
        Vector oneOverNumPatchPixels = constantVector(1.0 / numPatchPixels, numPatchPixels);
        Vector allOnesNumPatchPixels = constantVector(1.0, numPatchPixels);

        // Is this the first batch of data passed through the filter (i.e., the filter bank has not been
        // created yet)?
        if (!isFirstBatchDone()) {

            // Read image patches, normalize patches, and turn them into columns in the matrix X
            Matrix X = new DenseMatrix(numPatchValues, numPatches);
            int colIndex = 0;
            for (int i = 0; i < data.numInstances(); i++) {
                String fileName = data.instance(i).stringValue(0);
                BufferedImage img = null;
                try {
                    img = ImageIO.read(new File(fileName));
                    int xmax = 1 + img.getWidth() - m_cropSize;
                    int ymax = 1 + img.getHeight() - m_cropSize;
                    for (int p = 0; p < m_numPatchesPerImage; p++) {
                        BufferedImage patch = img.getSubimage(rand.nextInt(xmax), rand.nextInt(ymax), m_cropSize, m_cropSize);
                        int index = 0;
                        Vector vec = new DenseVector(numPatchValues);
                        for (int j = 0; j < m_cropSize; j++) {
                            for (int k = 0; k < m_cropSize; k++) {
                                int rgb = patch.getRGB(k, j);
                                int r = (rgb >> 16) & 0xFF;
                                int g = (rgb >> 8) & 0xFF;
                                int b = (rgb & 0xFF);
                                vec.set(index, r);
                                vec.set(numPatchPixels + index, g);
                                vec.set(2 * numPatchPixels + index, b);
                                index++;
                            }
                        }

                        if (i == 0) {
                            System.err.println(String.format("per channel normalization: %b", m_channel_normalize));
                        }
                        if (!m_channel_normalize) {
                            Vector centeredVec = vec.add(-vec.dot(oneOverNumPatchValues), allOnesNumPatchValues);
                            double norm = centeredVec.norm(Vector.Norm.Two);
                            Vector normalizedVec = centeredVec.scale(1.0 / Math.sqrt((norm * norm) / vec.size() + 10));
                            for (int r = 0; r < normalizedVec.size(); r++) {
                                X.set(r, colIndex, normalizedVec.get(r));
                            }
                        } else {

                            int row = 0;
                            for (int channel = 0; channel < 3; channel++) {
                                Vector subvector = Matrices.getSubVector(vec,
                                        IntStream.range(channel * numPatchPixels, (channel + 1) * numPatchPixels).toArray())
                                        .copy();
                                Vector centeredVec = subvector.add(-subvector.dot(oneOverNumPatchPixels), allOnesNumPatchPixels);
                                double norm = centeredVec.norm(Vector.Norm.Two);
                                Vector normalizedVec = centeredVec.scale(1.0 / Math.sqrt((norm * norm) / subvector.size() + 10));
                                for (int r = 0; r < normalizedVec.size(); r++) {
                                    X.set(row++, colIndex, normalizedVec.get(r));
                                }
                            }
                        }

                        colIndex++;
                    }
                } catch (IOException e) {
                    System.err.println("File " + fileName + " could not be read");
                }
            }
            if (m_Debug) {
                System.err.println("Calculating mean value for each pixel in X.");
            }
            Vector mean = X.mult(constantVector(1.0 / numPatches, numPatches), new DenseVector(numPatchValues));

            if (m_Debug) {
                System.err.println("Calculating centered version of X and storing it in S.");
            }
            Matrix S = new DenseMatrix(X);
            S = (new DenseMatrix(mean)).transBmultAdd(-1.0, new DenseMatrix(constantVector(1.0, numPatches)), S);

            if (m_Debug) {
                System.err.println("Calculating covariance matrix.");
            }
            Matrix cov = (new UpperSPDDenseMatrix(numPatchValues)).rank1(1.0 / numPatches, S);

            if (m_Debug) {
                System.err.println("Performing eigenvalue decomposition.");
            }
            SymmDenseEVD evd = SymmDenseEVD.factorize(cov);
            double[] evals = evd.getEigenvalues();
            Matrix V = evd.getEigenvectors();
            Matrix E = new UpperSymmDenseMatrix(evals.length);
            for (int i = 0; i < evals.length; i++) {
                E.set(i, i, 1.0 / Math.sqrt(evals[i] + 0.1));

            }
            if (m_Debug) {
                System.err.println("Whitening data.");
            }
            X = V.mult(E, new DenseMatrix(V.numRows(), E.numColumns())).transBmult(V, new UpperSymmDenseMatrix(V.numRows())).
                    mult(X, new DenseMatrix(V.numRows(), X.numColumns()));

            // ===========================================
            // BEGIN: ASSIGNMENT CODE BLOCK 1
            //        - FOR SPHERICAL K-MEANS HERE
            // -------------------------------------------
            int NUM_TRAIN_ITERATIONS = 200;

            BLAS blas = BLAS.getInstance();
            // deal with the different zero-based indices in F2jBLAS and one-based indices
            // in NativeRefBLAS/NativeSystemBLAS.
            boolean isNativeBLAS = !blas.getClass().getName().equals("com.github.fommil.netlib.F2jBLAS");
            IntFunction<Integer> fixBlasIndex = i -> (isNativeBLAS ? i : (i - 1));

            LOGGER.info("Seed is " + m_seed);

            // Prepare an array with length of (m_K * numPatchValues) for m_D initialization,
            // and initialize all elements to Gaussian distributed numbers with mean 0 and SD 1.

            double[] arrayD_ = new double[m_K * numPatchValues]; // the underlying data array of DenseMatrix m_D
            double[] l2Norms = new double[m_K];
            Arrays.fill(l2Norms, 0);
            for (int i = 0; i < arrayD_.length; i++) {
                // It's good enough to use the global random generator - we don't care about
                // the precision much.
                arrayD_[i] = rand.nextGaussian();
                l2Norms[i / numPatchValues] += arrayD_[i] * arrayD_[i];
            }

            // Normalize each column
            l2Norms = Arrays.stream(l2Norms).parallel().map(Math::sqrt).toArray();
            for (int i = 0; i < arrayD_.length; i++) {
                arrayD_[i] /= l2Norms[i / numPatchValues];
            }

            m_D = new DenseMatrix(numPatchValues, m_K, arrayD_, false);

            DenseMatrix P = new DenseMatrix(m_K, numPatches);

            double lastSse = Double.MAX_VALUE;
            for (int l = 0; l < NUM_TRAIN_ITERATIONS; l++) {
                // Compute the projections
                m_D.transAmult(X, P);

                // Update mappings S
                double[] arrayP_ = P.getData(); // the underlying data array of DenseMatrix S
                double[] longestComponents = new double[numPatches];
                int[] indicesOfLgstComp = new int[numPatches];
                for (int i = 0; i < numPatches; i++) {
                    // Set each s to sparse vector with the longest projection value remained.
                    double[] s = Arrays.copyOfRange(arrayP_, i * m_K, (i + 1) * m_K);
                    int idx = fixBlasIndex.apply(blas.idamax(m_K, s, 1));

                    longestComponents[i] = s[idx];
                    indicesOfLgstComp[i] = idx;
                }

                // Reuse the identifier S but it is no longer the same as in the whitening step above.
                // Now S is the matrix of code vectors.
                S = new DenseMatrix(P, false); // overwriting P
                S.zero();
                for (int i = 0; i < numPatches; i++) {
                    S.set(indicesOfLgstComp[i], i, longestComponents[i]);
                }

                // Update the dictionary matrix
                m_D = X.transBmultAdd(S, m_D);

                // Normalize each column of D
                l2Norms = new double[m_K];
                Arrays.fill(l2Norms, 0);
                for (int i = 0; i < arrayD_.length; i++) {
                    l2Norms[i / numPatchValues] += arrayD_[i] * arrayD_[i];
                }

                l2Norms = Arrays.stream(l2Norms).parallel().map(Math::sqrt).toArray();
                for (int i = 0; i < arrayD_.length; i++) {
                    arrayD_[i] /= l2Norms[i / numPatchValues];
                }

                // Measure the MSE and exit if it convergent earlier than expected.
                double fNorm = m_D
                        .mult(S, new DenseMatrix(X.numRows(), X.numColumns()))
                        .add(-1, X)
                        .norm(Matrix.Norm.Frobenius);
                double sse = fNorm * fNorm;

                if (m_Debug) {
                    LOGGER.info(String.format("Iteration %3d: K-mean training: SSE = %.10f (raw 0x%16x)", l, sse, Double.doubleToLongBits(sse)));
                }
                if (sse >= lastSse) {
                    if (m_Debug) {
                        LOGGER.info("K-mean training: stopped iteration due to convergence.");
                    }
                    break;
                }
                lastSse = sse;
            }


            // -------------------------------------------
            // END: ASSIGNMENT CODE BLOCK 1
            // ===========================================
        }

        // ==================================================
        // BEGIN: ASSIGNMENT CODE BLOCK 2
        //        - FOR CREATING FEATURE VECTORS
        // --------------------------------------------------

        Instances output = determineOutputFormat(data);

        int idxInstance = 0;
        if (data.numInstances() > 1) {
            LOGGER.info("Total " + data.numInstances() + " instances.");
        }
        for (Instance inst : data) {
            lastNanos = System.nanoTime();
            String fileName = inst.stringValue(0);
            BufferedImage img = null;

            try {
                img = ImageIO.read(new File(fileName));
            } catch (IOException e) {
                System.err.println("File " + fileName + " could not be read");
            }

            // The dimensions of all images have been checked in determineOutputFormat().  No need to check again
            // but just take the assumption that all images are square and of the same size.
            int imgSize = img.getWidth();
            addMeasurementTo("tf1");

            int numPatchesPerDimension = (imgSize - m_cropSize) / m_stride + 1;
            int numPatchesPerImage = numPatchesPerDimension * numPatchesPerDimension;

            double[] arrayX_ = new double[numPatchesPerImage * numPatchValues];

            int patchId = 0;
            for (int top = 0; top <= imgSize - m_cropSize; top += m_stride) {
                for (int left = 0; left <= imgSize - m_cropSize; left += m_stride) {
                    int[] pixels = new int[numPatchPixels];
                    img.getRGB(left, top, m_cropSize, m_cropSize, pixels, 0, m_cropSize);

                    // convert the channels: all Rs, all Gs and all Bs must be placed in the same order as
                    // that in training.
                    DoubleStream streamR = Arrays.stream(pixels).mapToDouble(i -> (i >> 16) & 0xff);
                    DoubleStream streamG = Arrays.stream(pixels).mapToDouble(i -> (i >> 8) & 0xff);
                    DoubleStream streamB = Arrays.stream(pixels).mapToDouble(i -> i & 0xff);

                    double[] patch = DoubleStream.concat(DoubleStream.concat(streamR, streamG), streamB).toArray();

                    if (true) {
                        DenseVector x = new DenseVector(patch, false);
                        x.add(-x.dot(oneOverNumPatchValues), allOnesNumPatchValues);
                        double norm = x.norm(Vector.Norm.Two);
                        x.scale(1.0 / Math.sqrt((norm * norm) / x.size() + 10));
                    }

                    System.arraycopy(patch, 0, arrayX_, patchId * numPatchValues, numPatchValues);
                    patchId++;
                }
            }

            // Patches prepared. Ready to apply the filter.
            Matrix X = new DenseMatrix(numPatchValues, numPatchesPerImage, arrayX_, false);
            addMeasurementTo("tf2");

            DenseMatrix Y = new DenseMatrix(m_K, X.numColumns());
            m_D.transAmult(X, Y);
            addMeasurementTo("tf3");

            // ## Soft-threshold encoding
            double[] arrayY_ = Y.getData();
            arrayY_ = Arrays.stream(arrayY_).parallel().map(y -> (y < 0) ? 0 : y).toArray();
            Y = new DenseMatrix(m_K, X.numColumns(), arrayY_, false);

            // ## Pooling stage
            int nFeatPerFilterAndDimension = numPatchesPerDimension / m_poolSize;
            // Prepare the array for pooling outputs, which also underlies the final feature data.
            double[][] arrayFeatures = new double[nFeatPerFilterAndDimension * nFeatPerFilterAndDimension][m_K];

            for (int gridY = 0; gridY < nFeatPerFilterAndDimension; gridY++) {
                for (int gridX = 0; gridX < nFeatPerFilterAndDimension; gridX++) {
                    // In every grid like this, (m_poolSize by m_poolSize) patches are combined to one output
                    // feature vector.  The DenseVectors are constructed by shallow copying, thus all operations
                    // on the vectors will indeed modify the array "arrayFeatures".
                    Vector feature = new DenseVector(arrayFeatures[gridY * nFeatPerFilterAndDimension + gridX], false);
                    feature.zero();

                    for (int offsetY = 0; offsetY < m_poolSize; offsetY++) {
                        for (int offsetX = 0; offsetX < m_poolSize; offsetX++) {
                            int unpoolGridX = gridX * m_poolSize + offsetX;
                            int unpoolGridY = gridY * m_poolSize + offsetY;
                            int columnPos = unpoolGridY * numPatchesPerDimension + unpoolGridX;
                            feature.add(Matrices.getColumn(Y, columnPos));
                        }
                    }
                    feature.scale(1.0 / (m_poolSize * m_poolSize));
                }
            }
            addMeasurementTo("tf4");

            // Assembly of instance's output
            DoubleStream streamFeatures = Arrays.stream(arrayFeatures).parallel().flatMapToDouble(Arrays::stream);
            DoubleStream streamClassValue = Arrays.stream(new double[]{inst.classValue()});
            double[] outputFeatures = DoubleStream.concat(streamFeatures, streamClassValue).toArray();
            addMeasurementTo("tf5");

            // Make a WEKA instance and add it to the dataset we return from this method
            output.add(new DenseInstance(inst.weight(), outputFeatures));
            addMeasurementTo("tf6");
            if (++idxInstance % 2000 == 0 && m_Debug) {
                LOGGER.info("Processed " + idxInstance + " instances.");
                StringBuilder timeReport = new StringBuilder("TIme periods:\n");
                for (String key : accumulatedMicros.keySet()) {
                    timeReport.append(String.format("  %s: %f\n", key, accumulatedMicros.get(key) / idxInstance / 1000));
                }
                System.err.print(timeReport);
            }
        }

        if (data.numInstances() > 1 && m_Debug) {
            StringBuilder timeReport = new StringBuilder("TIme periods:\n");
            for (String key : accumulatedMicros.keySet()) {
                timeReport.append(String.format("  %s: %f\n", key, accumulatedMicros.get(key) / data.numInstances() / 1000));
            }
            System.err.print(timeReport);
        }

        // --------------------------------------------------
        // END: ASSIGNMENT CODE BLOCK 2
        // ==================================================
        return output;


    }

    /**
     * A utility method for calculating the sum of squared errors during k-means iterations
     * based on the X matrix, the current S matrix, and the current dictionary stored in
     * a member variable. Useful for checking whether the error decreases monotonically,
     * which it should if k-means has been implemented correctly.
     *
     * @param X the X matrix
     * @param S the S matrix
     * @return the sum of squared errors
     */
    protected double calculateSumOfSquaredErrors(Matrix X, Matrix S) {

        double SSE = 0;
        for (int i = 0; i < X.numColumns(); i++) {
            Vector projected = m_D.mult(Matrices.getColumn(S, i), new DenseVector(X.numRows()));
            double n = Matrices.getColumn(X, i).add(-1.0, projected).norm(Vector.Norm.Two);
            SSE += n * n;
        }
        return SSE;
    }

    /**
     * The info shown in the GUI.
     * @return the info describing the filter.
     */
    public String globalInfo() {
        return "This filter performs feature extraction from images using the spherical k-means algorithm.";
    }

    /**
     * The capabilities of this filter.
     * @return the capabilities
     */
    public Capabilities getCapabilities() {
        Capabilities result = super.getCapabilities();
        result.enable(Capabilities.Capability.STRING_ATTRIBUTES);
        result.enableAllClasses();
        result.enable(Capabilities.Capability.NO_CLASS); // Filter doesn't require class to be set
        result.enable(Capabilities.Capability.MISSING_CLASS_VALUES);
        return result;
    }

    /**
     * We need to have access to the full input format so that we can read the images.
     *
     * @return true
     */
    public boolean allowAccessToFullInputFormat() {
        return true;
    }

    /**
     * Plots a vector as an image, assuming the image is square and has 3 colour channels given consecutively.
     * This method can potentially be used for debugging purposes.
     *
     * @param v the vector to plot
     * @param rescale whether to rescale the data to the 0-255 range before plotting it
     */
    protected void plotVector(Vector v, boolean rescale) {
        class MyPanel extends JPanel {
            protected void paintComponent(Graphics gr) {
                super.paintComponent(gr);
                int dim = (int) Math.round(Math.sqrt(v.size() / 3));
                int xSize = getWidth() / dim;
                int ySize = getHeight() / dim;
                int x = 0;
                int y = -ySize;
                double[] min = new double[3];
                double[] max = new double[3];
                if (rescale) { // Find minimum and maximum "intensity" value for each channel
                    for (int i = 0; i < v.size() / 3; i++) {
                        if (i % dim == 0) {
                            x = 0;
                            y += ySize;
                        }
                        double r = v.get(i); double g = v.get(i + v.size() / 3); double b = v.get(i + 2 * v.size() / 3);
                        if (min[0] > r) { min[0] = r; } if (min[1] > g) { min[1] = g; } if (min[2] > b) { min[2] = b; }
                        if (max[0] < r) { max[0] = r; } if (max[1] < g) { max[1] = g; } if (max[2] < b) { max[2] = b; }
                        x += xSize;
                    }
                    x = 0;
                    y = -ySize;
                } else {
                    for (int i = 0; i < 3; i++) {
                        max[i] = 255.0;
                    }
                }
                for (int i = 0; i < v.size() / 3; i++) {
                    if (i % dim == 0) {
                        x = 0;
                        y += ySize;
                    }
                    int r = (int) (255.0 * ((v.get(i) - min[0]) / (max[0] - min[0])));
                    int g = (int) (255.0 * ((v.get(i + v.size() / 3) - min[1]) / (max[1] - min[1])));
                    int b = (int) (255.0 * ((v.get(i + 2 * v.size() / 3) - min[2]) / (max[2] - min[2])));
                    gr.setColor(new Color(r, g, b));
                    gr.fillRect(x, y, xSize, ySize);
                    x += xSize;
                }
            }
        }
        MyPanel mainPanel = new MyPanel();
        JDialog d = new JDialog();
        d.setModal(true);
        d.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        d.add(mainPanel);
        d.setSize(10 * (int) Math.round(Math.sqrt(v.size())), 2 + 10 * (int) Math.round(Math.sqrt(v.size())));
        d.setResizable(false);
        d.setVisible(true);
    }

    /**
     * Returns a constant DenseVector with the given value in each slot.
     *
     * @param value  the constant to use
     * @param length the length of the vector
     * @return DenseVector
     */
    protected DenseVector constantVector(double value, int length) {
        double[] v = new double[length];
        Arrays.fill(v, value);
        return new DenseVector(v);
    }

    @OptionMetadata(
            displayName = "Seed for random number generation",
            description = "The seed value used by the random number generator.",
            displayOrder = 1,
            commandLineParamName = "S",
            commandLineParamSynopsis = "-S")
    public int getSeed() {
        return m_seed;
    }
    public void setSeed(int seed) {
        this.m_seed = seed;
    }

    @OptionMetadata(
            displayName = "Patch size to use (value X means X x X patches will be used)",
            description = "The patch size to use (value X means X x X patches will be used).",
            displayOrder = 2,
            commandLineParamName = "size",
            commandLineParamSynopsis = "-size")
    public int getCropSize() {
        return m_cropSize;
    }
    public void setCropSize(int cropSize) {
        this.m_cropSize = cropSize;
    }

    @OptionMetadata(
            displayName = "Number of patches per image",
            description = "The number of patches to be extracted per image.",
            displayOrder = 3,
            commandLineParamName = "numPatches",
            commandLineParamSynopsis = "-numPatches")
    public int getNumPatchesPerImage() {
        return m_numPatchesPerImage;
    }
    public void setNumPatchesPerImage(int numPatchesPerImage) {
        this.m_numPatchesPerImage = numPatchesPerImage;
    }

    @OptionMetadata(
            displayName = "Number of clusters",
            description = "The number of clusters/filters/dictionary atoms to learn.",
            displayOrder = 4,
            commandLineParamName = "K",
            commandLineParamSynopsis = "-K")
    public int getK() {
        return m_K;
    }
    public void setK(int K) {
        this.m_K = K;
    }

    @OptionMetadata(
            displayName = "Stride",
            description = "The stride to use when filters are applied to an image (both directions).",
            displayOrder = 5,
            commandLineParamName = "stride",
            commandLineParamSynopsis = "-stride")
    public int getStride() {
        return m_stride;
    }
    public void setStride(int stride) {
        this.m_stride = stride;
    }

    @OptionMetadata(
            displayName = "Pool size",
            description = "The size of the pool to use when creating features (both directions).",
            displayOrder = 6,
            commandLineParamName = "pool",
            commandLineParamSynopsis = "-pool")
    public int getPoolSize() {
        return m_poolSize;
    }
    public void setPoolSize(int pool) {
        this.m_poolSize = pool;
    }

    @OptionMetadata(
            displayName = "Per-channel normalization",
            description = "",
            commandLineParamName = "pcn",
            commandLineParamSynopsis = "-pcn"
    )
    public boolean isM_channel_normalize() {
        return m_channel_normalize;
    }
    public void setM_channel_normalize(boolean m_channel_normalize) {
        this.m_channel_normalize = m_channel_normalize;
    }

    /**
     * The main method used for running this filter from the command-line interface.
     *
     * @param options the command-line options
     */
    public static void main(String[] options) {
        runFilter(new KMeansImageFilter(), options);
    }
}
